#!/bin/sh

# Licensed Materials - Property of IBM
# OCO Source Materials
# 09N6996
# (C) Copyright IBM Corp. 2010 All Rights Reserved
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.

####################################
# printDeviceDrivers
####################################
printDeviceDrivers()
{
  count=0
  lsmod | while read DRIVER_NAME THE_REST
    do
    if [ "$DRIVER_NAME"  = "Module" ]; then
      continue
    fi
    versionStr=""
    versionJustFound="false"
    for FIRST in `modinfo $DRIVER_NAME 2>/dev/null`; 
      do
        if [ "$versionJustFound" = "true" ]; then
          versionJustFound="false"
          versionStr=$FIRST
        fi
        if [ "$FIRST" = "version:" ]; then
          versionJustFound="true"
        fi
    done
    if [ "$versionStr" != "" ]; then
        filePart=`modinfo $DRIVER_NAME | grep 'filename:' 2>/dev/null`
        descPart=`modinfo $DRIVER_NAME | grep 'description:' 2>/dev/null`
        pathName=/${filePart#*/*}
        fileName=${pathName##*/}
        descript=${descPart#description:    *}
        version=${versionStr%[*}
        softwareId=`rpm -qf $pathName`
        if [ "${softwareId#file }" != "$softwareId" ]; then
          softwareId=""
        fi
        echo "DeviceDriver.$count.Name=$DRIVER_NAME"
        echo "DeviceDriver.$count.Description=$descript"
        echo "DeviceDriver.$count.PathName=$pathName"
        echo "DeviceDriver.$count.FileName=$fileName"
        echo "DeviceDriver.$count.Version=$version"
        echo "DeviceDriver.$count.SoftwareID=$softwareId"
        echo "DeviceDriver.$count.Started=True"
        count=`expr $count + 1`
    fi
  done
  return
}

####################################
# main(String[] args)
####################################
  os_arch=`uname -m`

  if [ "${os_arch#s390}" = "$os_arch" ] && [ "${os_arch#*pc}" = "$os_arch" ]; then
    printDeviceDrivers
  fi
